#include "conf.hpp"

namespace conf {

int score_label_size=10;

int compute_score(int points, int total_buttons,
    int buttons,
    int maxsize,
    int size)
{
    if(buttons==total_buttons && size <= maxsize)
        return (points*maxsize)/size;
    if(buttons < total_buttons || size > maxsize){
        if(size <= maxsize) return buttons*(points/(2*total_buttons));
        else if (maxsize<size && size <= 2*maxsize) return buttons*(points*(2*maxsize-size)/(2*maxsize*total_buttons));
        else if (2*maxsize<size) return 0;
    }
    return 0;
}

}// namespace conf
